; Chgroudj! v1.1
; by pacHa [pacha07@caramail.com]

; Be careful to your ROM version or it will crash. :-(

; Sorry for people who don't speak french but most
; of the comments are in french.


.include	acebeta.inc

	.db	$cd,"Chgroudj!",6,"v1.1",0

#define	19.006					; you can change with 19.0, of course

gauche	=	SH_BUF	; byte
droite	=	SH_BUF + 1	; byte
score		=	SH_BUF + 2	; word
position	=	SH_BUF + 4	; byte
histo1	=	SH_BUF + 5	; byte
histo2	=	SH_BUF + 6	; byte
histo3	=	SH_BUF + 7	; byte
histo4	=	SH_BUF + 8	; byte
histo5	=	SH_BUF + 9	; byte
histo6	=	SH_BUF + 10	; byte
histo7	=	SH_BUF + 11	; byte

	CALL	CLEARLCD

	res	2,(iy+$0d)		; ca scrolle pas
	set	3,(iy+$05)		; texte invers

	ld	hl,$0000
	ld	(CURSOR_POS),hl
	ld	hl,txt_present
	CALL	D_ZT_STR

	res	3,(iy+$05)		; texte normal

	ld	hl,$0103
	ld	(CURSOR_POS),hl
	ld	hl,txt_start
	CALL	D_ZT_STR

	ld	hl,$0007
	ld	(CURSOR_POS),hl
	ld	hl,txt_pacha
	CALL	D_ZT_STR


wfkey:				; attend la pression d'une touche
	CALL	GET_KEY
	cp	G_0
	call	z,score_to_zero
	cp	0
	jr	z,wfkey

	CALL	CLEARLCD

	ld	a,8
	ld	(position),a

	ld	a,6
	ld	(gauche),a

	ld	hl,$0000
	ld	(score),hl

	set	2,(iy+$0d)		; ca scrolle


loop:

	ld	a,15			; Ca fait scroller
	ld	(CURSOR_COL),a	
	ld	a,' '
	CALL	TX_CHARPUT

	halt				; Ca ralentit un peu...
	halt

	ld	hl,(score)		; Augmente le score
	inc	hl
	ld	(score),hl

	ld	a,(position)	; Affiche le vaisseau
	ld	(CURSOR_COL),a
	ld	a,1
	ld	(CURSOR_ROW),a
	ld	a,$16
	CALL	TX_CHARPUT

	ld	a,7
	ld	(CURSOR_ROW),a


	CALL	RAND		;\	une routine de moi (!)
	ld	b,7		;|	qui met alatoirement
srl_loop:			;|	0 ou 1 dans a.
	srl	a		;|
	djnz	srl_loop	;/

	cp	1
	jp	z,plus
	ld	a,(gauche)
	dec	a
	ld	(gauche),a
aff:
	cp	$FF			; Si c'est trop  gauche...
	call	z,zero
	cp	8			; Si c'est trop  droite...
	call	z,sept
	add	a,7
	ld	(droite),a

	ld	(CURSOR_COL),a	; Affiche le bord droit
	ld	a,$9a
	CALL	TX_CHARPUT

	ld	a,(gauche)		; Affiche le bord gauche
	ld	(CURSOR_COL),a
	ld	a,$9b
	CALL	TX_CHARPUT

	CALL	GET_KEY
	cp	G_GRAPH
	jr	z,move_droite
	cp	G_RIGHT
	jr	z,move_droite
	cp	G_YEDIT
	jr	z,move_gauche
	cp	G_LEFT
	jr	z,move_gauche
	cp	G_CLEAR		; teacher key
	jp	z,EXIT_TIOS

	ld	a,(histo6)		; historique du circuit pour checker les collisions
	ld	(histo7),a
	ld	a,(histo5)
	ld	(histo6),a
	ld	a,(histo4)
	ld	(histo5),a
	ld	a,(histo3)
	ld	(histo4),a
	ld	a,(histo2)
	ld	(histo3),a
	ld	a,(histo1)
	ld	(histo2),a
	ld	a,(gauche)
	ld	(histo1),a

	ld	a,(histo7)		; checke la collision  gauche
	ld	b,a
	ld	a,(position)
	cp	b
	jp	z,fin

	ld	a,(histo7)		; checke la collision  droite
	add	a,7
	ld	b,a
	ld	a,(position)
	cp	b
	jp	nc,fin

	jp	loop

plus:
	ld	a,(gauche)
	inc	a
	ld	(gauche),a
	jp	aff

zero:
	xor	a			; ld	a,0
	ld	(gauche),a
	ret

sept:
	ld	a,7
	ld	(gauche),a
	ret
	
move_droite:
	ld	a,(position)
	inc	a
	ld	(position),a
	jp	loop

move_gauche:
	ld	a,(position)
	dec	a
	ld	(position),a
	jp	loop

fin:
	CALL	CLEARLCD
	ld	hl,$0001
	ld	(CURSOR_POS),hl
	ld	hl,txt_lose
	CALL	D_ZT_STR
	ld	hl,(score)

#ifdef 19.0
	CALL	$3896				; D_HL_DECI for 19.0
#endif

#ifdef 19.006
	CALL	$39af				; for 19.006 !
#endif

	ld	hl,(score)
	ld	de,(highscore)
	CALL	CP_HL_DE
	call	nc,new_high

	ld	hl,$0007
	ld	(CURSOR_POS),hl
	ld	hl,txt_high
	CALL	D_ZT_STR

	ld	hl,(highscore)

#ifdef 19.0
	CALL	$3896				; D_HL_DECI for 19.0
#endif

#ifdef 19.006
	CALL	$39af				; for 19.006 !
#endif

	CALL	PAUSE
	ret

new_high:
	ld	hl,(score)
	ld	(highscore),hl
	ld	hl,$0006
	ld	(CURSOR_POS),hl
	ld	hl,txt_n_high
	CALL	D_ZT_STR
	ret

score_to_zero:
	ld	hl,$0000
	ld	(highscore),hl
	ret

txt_present:
	.db	" * Chgroudj ! * ",0

txt_pacha:
	.db	"  * by pacHa *",0

txt_start:
	.db	"Hit any key...",0

txt_lose:
	.db	"You chgroudjed !"
	.db	" Score : ",0

txt_n_high:
	.db	"New highscore !",0

txt_high:
	.db	"High is",0

highscore:
	.dw	0

.end